## hdf-eos5 5.1.15.dfsg.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5 C CXX)

#-----------------------------------------------------------------------------
# Instructions for use : Normal Build
#
# For standard build of HDFEOS5 libraries,tests and tools. 
# Run cmake using the HDFEOS5 source tree to generate a build tree.
# Enable/Disable options according to requirements and
# set CMAKE_INSTALL_PREFIX to the required install path.
# Make install can be used to install all components for system-wide use.
#
#-----------------------------------------------------------------------------
# Instructions for use : Sub-Project Build
#
# To include HDFEOS5 as a sub-project within another project. 
# Set HDFEOS5_EXTERNALLY_CONFIGURED to 1 in the parent project and
# supply values for the following variables...
#
# HDFEOS_EXPORTED_TARGETS :
#   Set this to the name of the targets variable which controls exports
#   If unset (because parent project does not support/use the 
#   INSTALL (EXPORT target...) syntax), then targets are not configured 
#   for export during install.
#
# HDFEOS5_LIB_DEPENDENCIES :
#   If the build of HDFEOS5 libs is being customized, then rules for the
#   dependencies of the HDFEOS5 libs may be 'incomplete', add additional
#   dependencies to this variable so that external projects pick them up
#
# HDFEOS5_EXTERNAL_LIB_PREFIX :
#   If the pa5rent project needs to install hdf libraries, but avoid 
#   name conflicts with system versions, then a prefix may be added
#   to ensure that the correct versions configured are used.
#
# Consider this example, it builds its own zlib
# library and tells HDFEOS5 to add it as a dependency - this ensures that
# any project making use of this build of HDFEOS5 will use the correct zlib
#
#   # Tell HDFEOS5 that we are manually overriding certain settings
#   SET (HDFEOS5_EXTERNALLY_CONFIGURED 1)
#   # Avoid duplicating names of installed libraries
#   SET (HDFEOS5_EXTERNAL_LIB_PREFIX "prj")
#   # Targets linking to the HDFEOS5 libs need to know their names
#   # if they are changed in the sub project, they should be here too
#   SET (HDFEOS5_LIB_NAME "prjHDFEOS5")
#   SET (HDFEOS5_MF_LIB_NAME "prjHDFEOS5_mf")
#   SET (HDFEOS5_LIBRARY "${HDFEOS5_LIB_NAME};${HDFEOS5_MF_LIB_NAME}")
#   # Export configuration to this export variable
#   SET (HDFEOS_EXPORTED_TARGETS "project-targets")
#
#   # Setup all necessary overrides for zlib so that HDFEOS5 uses our
#   # internally compiled zlib rather than any other version
#   IF (HDF_ENABLE_Z_LIB_SUPPORT)
#    # We must tell the main HDFEOS library that it depends on our zlib 
#     SET (HDFEOS5_LIB_DEPENDENCIES prjzlib)    
#     # Override the zlib header file
#     IF (PRJ_USE_SYSTEM_ZLIB)
#       SET (HEOS_ZLIB_HEADER "zlib.h")
#     ELSE (PRJ_USE_SYSTEM_ZLIB)
#      SET (HEOS_ZLIB_HEADER "prj_zlib.h")
#       # Set vars that FindZlib would have set if used in sub project
#       SET (ZLIB_INCLUDE_DIRS "${PRJ_ZLIB_INCLUDE_DIRS}")
#       SET (ZLIB_LIBRARIES prjzlib)
#     ENDIF (PRJ_USE_SYSTEM_ZLIB)
#  ENDIF (HDF_ENABLE_Z_LIB_SUPPORT)
#   
#   # Add the sub project
#   ADD_SUBDIRECTORY (Utilities/HDFEOS-1.2)
#   # Add the HDFEOS dirs to our include path
#   SET (HDFEOS5_INCLUDE_DIR 
#       ${PROJECT_SOURCE_DIR}/Utilities/HDFEOS-1.2/src
#       ${PROJECT_BINARY_DIR}/Utilities/HDFEOS-1.2
#   )
#
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Allow Visual Studio solution directories
#-----------------------------------------------------------------------------
# Provide a way for Visual Studio Express users to turn OFF the new FOLDER
# organization feature. Default to ON for non-Express users. Express users must
# explicitly turn off this option to build HDFEOS in the Express IDE...
#
OPTION (HDFEOS5_USE_FOLDERS "Enable folder grouping of projects in IDEs." ON)
MARK_AS_ADVANCED (HDFEOS5_USE_FOLDERS)
IF (HDFEOS5_USE_FOLDERS)
  SET_PROPERTY (GLOBAL PROPERTY USE_FOLDERS ON)
ENDIF (HDFEOS5_USE_FOLDERS)
OPTION (HDFEOS5_NO_PACKAGES "CPACK - Disable packaging" OFF)
MARK_AS_ADVANCED (HDFEOS5_NO_PACKAGES)

#-----------------------------------------------------------------------------
# Set the core names of all the libraries
#-----------------------------------------------------------------------------
SET (HDFEOS_GCTP_SRC_LIB_CORENAME     "Gctp")
SET (HDFEOS_SRC_LIB_CORENAME          "he5_hdfeos")

#-----------------------------------------------------------------------------
# Set the true names of all the libraries if customized by external project
#-----------------------------------------------------------------------------
SET (HDFEOS_GCTP_SRC_LIB_NAME     "${HDFEOS5_EXTERNAL_LIB_PREFIX}${HDFEOS_GCTP_SRC_LIB_CORENAME}")
SET (HDFEOS_SRC_LIB_NAME          "${HDFEOS5_EXTERNAL_LIB_PREFIX}${HDFEOS_SRC_LIB_CORENAME}")

#-----------------------------------------------------------------------------
# Set the target names of all the libraries
#-----------------------------------------------------------------------------
SET (HDFEOS_GCTP_SRC_LIB_TARGET     ${HDFEOS_GCTP_SRC_LIB_NAME})
SET (HDFEOS_SRC_LIB_TARGET          ${HDFEOS_SRC_LIB_NAME})

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
SET (EOS_RESOURCES_DIR          ${HDFEOS5_SOURCE_DIR}/config/cmake)
SET (HDFEOS_GCTP_SRC_DIR        ${HDFEOS5_SOURCE_DIR}/gctp/src)
SET (HDFEOS_GCTP_INC_DIR        ${HDFEOS5_SOURCE_DIR}/gctp/include)
SET (HDFEOS_SRC_DIR             ${HDFEOS5_SOURCE_DIR}/src)
SET (HDFEOS_INC_DIR             ${HDFEOS5_SOURCE_DIR}/include)
SET (HDFEOS_SAMPLES_SRC_DIR     ${HDFEOS5_SOURCE_DIR}/samples)

IF (NOT HDFEOS_INSTALL_BIN_DIR)
  SET (HDFEOS_INSTALL_BIN_DIR bin)
ENDIF (NOT HDFEOS_INSTALL_BIN_DIR)
IF (NOT HDFEOS_INSTALL_LIB_DIR)
  SET (HDFEOS_INSTALL_LIB_DIR lib)
ENDIF (NOT HDFEOS_INSTALL_LIB_DIR)
IF (NOT HDFEOS_INSTALL_INCLUDE_DIR)
  SET (HDFEOS_INSTALL_INCLUDE_DIR include)
ENDIF (NOT HDFEOS_INSTALL_INCLUDE_DIR)
IF (NOT HDFEOS_INSTALL_DATA_DIR)
  IF (NOT WIN32)
    SET (HDFEOS_INSTALL_DATA_DIR share)
    SET (HDFEOS_INSTALL_CMAKE_DIR share/cmake)
  ELSE (NOT WIN32)
    SET (HDFEOS_INSTALL_DATA_DIR ".")
    SET (HDFEOS_INSTALL_CMAKE_DIR cmake)
  ENDIF (NOT WIN32)
ENDIF (NOT HDFEOS_INSTALL_DATA_DIR)

#-----------------------------------------------------------------------------
# parse the full version number
#-----------------------------------------------------------------------------
FILE (READ ${HDFEOS_INC_DIR}/HE5_HdfEosDef.h _he5_hdfeosdef_h_contents)
STRING (REGEX REPLACE ".*#define[ \t]+HE5_HDFEOSVERSION[ \t]+\"([0-9]*.[0-9]*)\".*"
    "\\1" HDFEOS5_FULL_VERSION ${_he5_hdfeosdef_h_contents})
STRING (REGEX REPLACE ".*#define[ \t]+HE5_HDFEOSVERSION[ \t]+\"([0-9]*).*$"
    "\\1" HDFEOS5_VERS_MAJOR ${_he5_hdfeosdef_h_contents})
STRING (REGEX REPLACE ".*#define[ \t]+HE5_HDFEOSVERSION[ \t]+\"[0-9]*.([0-9]*).*$"
    "\\1" HDFEOS5_VERS_MINOR ${_he5_hdfeosdef_h_contents})
STRING (REGEX REPLACE ".*#define[ \t]+HE5_HDFEOSVERSION[ \t]+\"[0-9]*.[0-9]*.([0-9]*)\".*$"
    "\\1" HDFEOS5_VERS_RELEASE ${_he5_hdfeosdef_h_contents})
MESSAGE (STATUS "VERSION: ${HDFEOS5_VERSION}")
#SET (HDFEOS5_VERS_MAJOR 1)
#SET (HDFEOS5_VERS_MINOR 0)
#SET (HDFEOS5_VERS_RELEASE 0)
#MESSAGE (STATUS "VERSION: ${HDFEOS5_VERSION}")

#-----------------------------------------------------------------------------
# Basic HDFEOS stuff here
#-----------------------------------------------------------------------------
SET (HDFEOS5_PACKAGE "hdf-eos5")
SET (HDFEOS5_PACKAGE_NAME "hdf-eos5")
SET (HDFEOS5_PACKAGE_VERSION "${HDFEOS5_VERS_MAJOR}.${HDFEOS5_VERS_MINOR}.${HDFEOS5_VERS_RELEASE}")
SET (HDFEOS5_PACKAGE_VERSION_MAJOR "${HDFEOS5_VERS_MAJOR}.${HDFEOS5_VERS_MINOR}")
SET (HDFEOS5_PACKAGE_VERSION_MINOR "${HDFEOS5_VERS_RELEASE}")
SET (HDFEOS5_PACKAGE_STRING "${HDFEOS5_PACKAGE_NAME} ${HDFEOS5_PACKAGE_VERSION}")
SET (HDFEOS5_PACKAGE_TARNAME "hdf-eos5")
SET (HDFEOS5_PACKAGE_URL "http://www.hdfgroup.org")
SET (HDFEOS5_PACKAGE_BUGREPORT "help@hdfgroup.org")

#-----------------------------------------------------------------------------
# Include some macros for reusable code
#-----------------------------------------------------------------------------
INCLUDE (${EOS_RESOURCES_DIR}/EOSMacros.cmake)
INCLUDE (${EOS_RESOURCES_DIR}/HDFEOSMacros.cmake)
INCLUDE (${EOS_RESOURCES_DIR}/HDF5Macros.cmake)

#-----------------------------------------------------------------------------
# Setup output Directories
#-----------------------------------------------------------------------------
IF (NOT HDFEOS5_EXTERNALLY_CONFIGURED)
  SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Executables."
  )
  SET (CMAKE_LIBRARY_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Libraries"
  )
  SET (CMAKE_ARCHIVE_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all static libraries."
  )
ELSE (NOT HDFEOS5_EXTERNALLY_CONFIGURED)
  # if we are externally configured, but the project uses old cmake scripts
  # this may not be set and utilities like Hdetect will fail
  IF (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
  ENDIF (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
ENDIF (NOT HDFEOS5_EXTERNALLY_CONFIGURED)

#-----------------------------------------------------------------------------
# Targets built within this project are exported at Install time for use
# by other projects using FindEOS5.
#-----------------------------------------------------------------------------
IF (NOT HDFEOS_EXPORTED_TARGETS)
  SET (HDFEOS_EXPORTED_TARGETS "hdfeos5-targets")
ENDIF (NOT HDFEOS_EXPORTED_TARGETS)

#-----------------------------------------------------------------------------
# To include a library in the list exported by the project AT BUILD TIME,
# add it to this variable. This is NOT used by Make Install, but for projects
# which include HDFEOS as a sub-project within their build tree
#-----------------------------------------------------------------------------
SET_GLOBAL_VARIABLE (HDFEOS_LIBRARIES_TO_EXPORT "")
SET_GLOBAL_VARIABLE (HDFEOS_APPS_TO_EXPORT "")
SET (EXTERNAL_HEADER_LIST "")
SET (EXTERNAL_LIBRARY_LIST "")
SET (EXTERNAL_LIBRARYDLL_LIST "")

#-----------------------------------------------------------------------------
# Run all the CMake configuration tests for our build environment
#-----------------------------------------------------------------------------
INCLUDE (${EOS_RESOURCES_DIR}/ConfigureChecks.cmake)

#-----------------------------------------------------------------------------
# Option to use legacy naming for windows libs/programs, default is legacy
#-----------------------------------------------------------------------------
IF (WIN32 AND NOT CYGWIN)
  OPTION (HDFEOS5_LEGACY_NAMING "Use Legacy Names for Libraries and Programs" ON)
ENDIF (WIN32 AND NOT CYGWIN)

#-----------------------------------------------------------------------------
# Option to Build Shared/Static libs, default is static
#-----------------------------------------------------------------------------
OPTION (BUILD_SHARED_LIBS "Build Shared Libraries" OFF)
SET (LIB_TYPE STATIC)
IF (BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
  SET (HDFEOS5_BUILT_AS_DYNAMIC_LIB 1)
  ADD_DEFINITIONS (-DHDFEOS5_BUILT_AS_DYNAMIC_LIB)
  ADD_DEFINITIONS (-DH5_BUILT_AS_DYNAMIC_LIB)
ELSE (BUILD_SHARED_LIBS)
  SET (HDFEOS5_BUILT_AS_STATIC_LIB 1)
  ADD_DEFINITIONS (-DHDFEOS5_BUILT_AS_STATIC_LIB)
  ADD_DEFINITIONS (-DH5_BUILT_AS_STATIC_LIB)
  IF (NOT WIN32)
    # should this be a user setting : Everyone uses it anyway ?
    ADD_DEFINITIONS (-DPIC)
  ENDIF (NOT WIN32)
ENDIF (BUILD_SHARED_LIBS)

IF (NOT USE_SHARED_LIBS)
  SET (HDFEOS5_USE_STATIC_LIBRARIES 1)
ENDIF (NOT USE_SHARED_LIBS)

=== Makefile ===
#----------------------------------------------------------------------------
# file:         makefile for HDF-EOS5 (for internal ECS usage only)
#
# environment:  requires environment established by the ECS .buildrc file
# 
# environment variables dependencies:
#   MAKECMD  make command to be run on make files
#   ARCH     architecture (i.e. hardware/os type)
#
#
# author:  Guru Tej S. Khalsa / Space Applications Corp.
#          Abe Taaheri / Emergent Information Technologies, Inc.
#
# history:
#       10-Nov-1997 GTSK Initital version
#       11-Apr-2001 AT   modified for HDFEOS5 and HDF5
#       19-Jul-2001 DaW  Modified because it broke the Build
#       05-Apr-2004 AT   Modified for DAAC Linux Delivery
#       02-Feb-2013 AT   Modified for Toolkit Linux64 build in clearcase
#
#
# notes:
#       1) This file is only for use by ECS Configuration Management (CM)
#	   personnel and software.  This file should not be distributed
#	   as part of the standard HDF-EOS5 delivery.
#----------------------------------------------------------------------------

# define shell to be used (use ksh so we can use the "." command)

SHELL=/bin/ksh

# define MAKE to be equivalant to $(MAKECMD)

MAKE=$(MAKECMD)

# define the location of the HDF-EOS5 STAGE area

HE_STAGE=/ecs/formal/STAGE/hdfeos5

# define the location of the standard HDF-EOS5 development area

HE_HOME=/ecs/hdfeos5

# define HDF5 base directory

#HE_ENV=$(ARCH)

# define the location of tar files

TAR_HOME=$(HE_HOME)/install

HDF_BASE=/ecs/cots/hdf

# define current HDF version

CURRENT_HDF4=HDF4.2.6
CURRENT_HDF=hdf5-1.8.8
CURRENT_SZIP=szip-2.1

# define SDP Toolkit home directory

TK_HOME=/ecs/formal/TOOLKIT

# name of tar files for delivery
HDFEOS5_SOURCE_TAR=HDF-EOS5.1.15.tar
HDFEOS5_TESTDRIVERS_TAR=HDF-EOS5.1.15_TESTDRIVERS.tar

# define the default compiler optimization level
OPT_LVL=-g

# define default target

default:
	@echo "This file is for use by ECS Configuration Management processes only."

# define a target to build BOTH variations (or "flavors") of HDF-EOS5
# for a given "brand" (i.e. architecture type)

full: opt debug

# define a target to build the "debug" variation (or "flavor") of HDF-EOS5
# for a given "brand" (i.e. architecture type) ("debug" means the library
# will be compiled for use in a souce code debugger)

debug:
	@$(MAKE) flavor_dir FLAVOR=$@
	@export use_flavor=1; $(MAKE) $(TARGET) OPT_LVL=-g FLAVOR=$@

# define a target to build the "optimized" variation (or "flavor") of
# HDF-EOS5 for a given "brand" (i.e. architecture type) ("optimized" means the
# library will be optimized for execution speed by the compiler)

opt:
	@$(MAKE) flavor_dir FLAVOR=$@
	@export use_flavor=1; $(MAKE) $(TARGET) OPT_LVL=-O FLAVOR=$@

# define standard CM targets

# NOTE: The standard targets defined by ECS CM are:
#       BuildImake, ProductHs, ProductLibs, LastPass, Deliver
#
#       Here the above targets are shadowed by the targets:
#       BuildImake2, ProductHs2, ProductLibs2, LastPass2, Deliver2
#       respectively.  The original targets only call the target
#       HE_ENV which sets up the HDF-EOS5 environment and then
#       builds the shadow target.
#       For SGI 32 Falvor build or linux 12 Falvor build these targets
#       renamed to FL_......


BuildImake:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

BuildImake2:
	@echo "No Imakefile to build."

ProductHs:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

ProductHs2:
	@echo "No header files to generate or promote."

ProductLibs: ProductLibs32 ProductLibs64

ProductLibs32:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

ProductLibs322:
	@if [ ! -e $(HDFEOS5_HOME)/lib/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/lib;			\
		ln -s `basename $(HDFEOS5_LIB)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp5

ProductLibs64:
	@$(MAKE) $(MFLAGS) HE_ENV64 TARGET=$@2

ProductLibs642:
	@if [ ! -e $(HDFEOS5_HOME)/lib/$(ARCH)64 ] ; then	\
		cd $(HDFEOS5_HOME)/lib;			\
		ln -s `basename $(HDFEOS5_LIB)` $(ARCH)64;\
	fi
	@cd $(HDFEOS5_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp5

LastPass:LastPass32 LastPass64

LastPass32:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

LastPass322:
	@if [ ! -e $(HDFEOS5_HOME)/bin/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/bin;			\
		ln -s `basename $(HDFEOS5_BIN)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/util; $(MAKE) $(MFLAGS) all

LastPass64:
	@$(MAKE) $(MFLAGS) HE_ENV64 TARGET=$@2

LastPass642:
	@if [ ! -e $(HDFEOS5_HOME)/bin/$(ARCH)64 ] ; then	\
		cd $(HDFEOS5_HOME)/bin;			\
		ln -s `basename $(HDFEOS5_BIN)` $(ARCH)64;\
	fi
	@cd $(HDFEOS5_HOME)/util; $(MAKE) $(MFLAGS) all

#	@echo "No utilites to build."

FL_BuildImake:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_BuildImake2:
	@echo "No Imakefile to build."

FL_ProductHs:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_ProductHs2:
	@echo "No header files to generate or promote."

FL_ProductLibs:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_ProductLibs2:
	@if [ ! -e $(HDFEOS5_HOME)/lib/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/lib;			\
		ln -s `basename $(HDFEOS5_LIB)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/src; $(MAKE) $(MFLAGS) all
	@cd $(TK_HOME)/src/GCT/freeware; $(MAKE) $(MFLAGS) gctp5

FL_LastPass:
	@$(MAKE) $(MFLAGS) FL_HE_ENV TARGET=$@2

FL_LastPass2:
	@if [ ! -e $(HDFEOS5_HOME)/bin/$(ARCH) ] ; then	\
		cd $(HDFEOS5_HOME)/bin;			\
		ln -s `basename $(HDFEOS5_BIN)` $(ARCH);\
	fi
	@cd $(HDFEOS5_HOME)/util; $(MAKE) $(MFLAGS) all

#	@echo "No utilites to build."



Deliver:
	@$(MAKE) $(MFLAGS) HE_ENV TARGET=$@2

Deliver2:
#	cp -rf /ecs/hdfeos/gctp .
#	chmod 0755 gctp/src/* gctp/include/*
	tar cvfX $(TAR_HOME)/$(HDFEOS5_SOURCE_TAR) $(HE_HOME)/make_exclude_list -C /ecs hdfeos5
	tar cvfX $(TAR_HOME)/$(HDFEOS5_TESTDRIVERS_TAR)  $(HE_HOME)/testdrivers/make_exclude_list -C /ecs  hdfeos5/testdrivers

DaacDeliver:
	@if [ $(ARCH) = "sgi6n32" ] ; then				    \
		for arch in sgi6n32 sgi6 ; do			    	    \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
				$(MAKECMD) full TARGET=$$targ ARCH=$$arch;  \
			done;						    \
		done;							    \
	elif [ $(ARCH) = "irix65" ] ; then				    \
		for arch in sgi6n32 sgi6 ; do			            \
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	    \
				$(MAKECMD) full TARGET=$$targ ARCH=$$arch;  \
			done;						    \
		done;                                                       \
	else								    \
		for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do		    \
			$(MAKECMD) full TARGET=$$targ;			    \
		done;							    \
	fi

LinuxDaacDeliver:  
	@if [ $(ARCH) = "linux" ] ; then				\
		for arch in linux ; do					\
			for targ in FL_ProductHs FL_ProductLibs FL_LastPass ; do	\
			$(MAKECMD) full TARGET=$$targ ARCH=$$arch;	\
		done ;							\
		done ;							\
	fi



# this is a special target used to establish the HDF-EOS5 environment

FL_HE_ENV:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;			\
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;		\
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux; brand=$(ARCH) ;;  \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	postfix=""; 						\
	opt_flag=-O;						\
	case $(FLAVOR) in					\
		*debug)						\
			opt_flag=-g;				\
			postfix=_debug;				\
		;;						\
	esac;							\
	HDFEOS5_HOME=$(HE_HOME);				\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS5_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/$${brand}$$postfix/hdfeos_env.ksh;	\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDF5INC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDF5LIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDF5INC PGSINC SZIPINC SZIPLIB HDF5LIB;	\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/lib		\
	export HDFINC HDFLIB;					\
	$(MAKE) $(MFLAGS) $(TARGET)


HE_ENV:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;			\
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;		\
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux; brand=$(ARCH) ;;    \
		*)       brand=$(ARCH); ;;			\
	esac;							\
	HDFEOS5_HOME=$(HE_HOME);				\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS5_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/tmp/hdfeos_env.ksh.tmp;		\
	if [ $(ARCH) = "linux" ] ; then				\
	CC="gcc -m32";						\
	export CC;						\
	LNX_COMP_FLAG="-m32";					\
	export LNX_COMP_FLAG;					\
	fi;							\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDF5INC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDF5LIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDF5INC PGSINC SZIPINC SZIPLIB HDF5LIB;	\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/lib		\
	export HDFINC HDFLIB;					\
	$(MAKE) $(MFLAGS) $(TARGET)

HE_ENV64:
	@case $(ARCH) in					\
		hp10)    brand=hp;      ;;			\
		sgi6n32) brand=sgi32; sgi_mode=n32;  ;;		\
		irix65)  brand=irix65; sgi_mode=65   ;;         \
		sgi6)    brand=sgi64; sgi_mode=64;  ;;		\
		sun5.5)  brand=sun5;    ;;			\
		sun5.8)  brand=sun5.8;    ;;			\
		linux)   LINUX_BRAND=linux64; brand=$(ARCH)64 ;;\
		*)       brand=$(ARCH); ;;			\
	esac;							\
	HDFEOS5_HOME=$(HE_HOME);				\
	opt_flag=$(OPT_LVL);					\
	export HDFEOS5_HOME sgi_mode opt_flag LINUX_BRAND;	\
	. $(HE_HOME)/bin/tmp/hdfeos_env.ksh.tmp;		\
	if [ $(ARCH) = "linux" ] ; then				\
	CC="gcc";						\
	export CC;						\
	LNX_COMP_FLAG="";					\
	export LNX_COMP_FLAG;					\
	fi;							\
	MAKE="$(MAKECMD)";					\
	AR='ar r';						\
	HDF5INC=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/include;	\
	HDF5LIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF)/lib		\
	PGSINC=$(TK_HOME)/include;				\
	SZIPLIB=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	SZIPINC=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	export MAKE AR HDF5INC PGSINC SZIPINC SZIPLIB HDF5LIB;	\
	HDFINC=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/include;	\
	HDFLIB=$(HDF_BASE)/$$brand/$(CURRENT_HDF4)/lib		\
	export HDFINC HDFLIB;					\
	$(MAKE) $(MFLAGS) $(TARGET)

flavor_dir:
	@sgi_mode=sgi32;					\
	LNX_COMP_FLAG="-m32";			                \
	export LNX_COMP_FLAG;					\
	opt_flag=-O;						\
	postfix="";						\
	case $(FLAVOR) in					\
		*debug)						\
			opt_flag=-g;				\
			postfix=_debug;				\
		;;						\
	esac;							\
	case $(ARCH) in						\
		hp10)						\
			brand=hp;				\
		;;						\
		sgi6n32)					\
			brand=sgi32;				\
			sgi_mode=n32;				\
		;;						\
		irix65)                                         \
			brand=irix65;				\
			sgi_mode=65;				\
		;;						\
		sgi6)						\
			brand=sgi64;				\
			sgi_mode=64;				\
		;;						\
		sun5.5)						\
			brand=sun5;				\
		;;						\
		sun5.8)						\
			brand=sun5.8;				\
		;;						\
		*)						\
			brand=$(ARCH);				\
		;;						\
	esac;							\
	he_obj=$(HE_HOME)/obj/$${brand}$$postfix;		\
	he_lib=$(HE_HOME)/lib/$${brand}$$postfix;		\
	he_bin=$(HE_HOME)/bin/$${brand}$$postfix;		\
	tmpdir=$(HE_HOME)/bin/tmp;				\
	if [ ! -d $$he_obj ] ; then				\
		mkdir $$he_obj;					\
	fi;							\
	if [ ! -d $$he_lib ] ; then				\
		mkdir $$he_lib;					\
	fi;							\
	if [ ! -d $$he_bin ] ; then				\
		mkdir $$he_bin;					\
	fi;							\
	hdf5lib=$(HDF_BASE)/$${brand}/$(CURRENT_HDF)/lib;	\
	hdf5inc=$(HDF_BASE)/$${brand}/$(CURRENT_HDF)/include;	\
	sziplib=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/lib;	\
	szipinc=$(HDF_BASE)/$${brand}/$(CURRENT_SZIP)/include;	\
	if [ ! -f $$he_bin/hdfeos_env.csh ] ; then			\
		cd $$he_bin;						\

=== testdrivers/threads/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_TESTDRIVERS_THREADS)

SET (threads_testdrivers
    he5_gd_threads-1
    he5_gd_threads-2
    he5_pt_threads-1
    he5_pt_threads-2
    he5_sw_threads-1
    he5_sw_threads-2
)

FOREACH (testdriver ${threads_testdrivers})
  ADD_EXECUTABLE (${testdriver} ${PROJECT_SOURCE_DIR}/${testdriver}.c)
  TARGET_NAMING (${testdriver} ${LIB_TYPE})
  TARGET_LINK_LIBRARIES (${testdriver} ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
ENDFOREACH (testdriver ${threads_testdrivers})
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  FOREACH (testdriver ${threads_testdrivers})
    ADD_TEST (NAME THREADS_${testdriver} COMMAND $<TARGET_FILE:${testdriver}>)
  ENDFOREACH (testdriver ${threads_testdrivers})

ENDIF (BUILD_TESTING)

=== testdrivers/za/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)
PROJECT (HDFEOS5_TESTDRIVERS_ZA)

ADD_EXECUTABLE (testza ${PROJECT_SOURCE_DIR}/TestZa.c)
TARGET_NAMING (testza ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testza ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

ADD_EXECUTABLE (testalias ${PROJECT_SOURCE_DIR}/TestAlias.c)
TARGET_NAMING (testalias ${LIB_TYPE})
TARGET_LINK_LIBRARIES (testalias ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})

IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  # make test dir
  FILE (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")

  IF (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testza_f ${PROJECT_SOURCE_DIR}/testza32.f)
  ELSE (F2CFORTRAN_32PTR)
    ADD_EXECUTABLE (testza_f ${PROJECT_SOURCE_DIR}/testza64.f)
  ENDIF (F2CFORTRAN_32PTR)
  TARGET_NAMING (testza_f ${LIB_TYPE})
  TARGET_FORTRAN_WIN_PROPERTIES (testza_f "")
  SET_TARGET_PROPERTIES (testza_f PROPERTIES LINKER_LANGUAGE Fortran)
  TARGET_LINK_LIBRARIES (testza_f ${HDFEOS_SRC_LIB_TARGET} ${HDFEOS_GCTP_SRC_LIB_TARGET} ${LINK_LIBS})
ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
  
##############################################################################
##############################################################################
###           T H E   T E S T S                                            ###
##############################################################################
##############################################################################
IF (BUILD_TESTING)

  ADD_TEST (NAME ZA_test_c COMMAND $<TARGET_FILE:testza>)

  ADD_TEST (NAME ZA_test_c_alias COMMAND $<TARGET_FILE:testalias>)
  SET_TESTS_PROPERTIES (ZA_test_c_alias PROPERTIES DEPENDS ZA_test_c)

  IF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)
    ADD_TEST (NAME ZA_test_f COMMAND $<TARGET_FILE:testza_f>)
    SET_TESTS_PROPERTIES (ZA_test_f PROPERTIES WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/fortran")
    SET_TESTS_PROPERTIES (ZA_test_f PROPERTIES DEPENDS ZA_test_c_alias)
  ENDIF (HDFEOS_BUILD_FORTRAN AND HAVE_F2CFORTRAN_MACRO)

ENDIF (BUILD_TESTING)

=== debian/control ===
Source: hdf-eos5
Section: libs
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Standards-Version: 3.9.5
Homepage: http://www.hdfeos.org
Build-Depends: debhelper (>= 9), dh-buildinfo, gfortran, libhdf5-serial-dev, libjpeg-dev, zlib1g-dev, autotools-dev, libtool, libgctp-dev, chrpath, autoconf, automake, dh-autoreconf

Package: libhe5-hdfeos0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Earth Observation System extensions to HDF5
 HDF-EOS5 is a software library designed built on HDF5 to support EOS-specific
 data structures, namely Grid, Point, and Swath. The new data structures 
 are constructed from standard HDF data objects, using EOS conventions, through
 the use of a software library [1,4]. A key feature of HDF-EOS files is that
 instrument-independent services, such as subsetting by geolocation, can be
 applied to the files across a wide variety of data products. 
 The library is extensible and new data structures can be added.

Package: libhe5-hdfeos-dev
Architecture: any
Section: libdevel
Depends: libhe5-hdfeos0 (= ${binary:Version}), ${misc:Depends}
Recommends: pkg-config
Description:  Development files for the HDF-EOS5 library
 HDF-EOS5 is a software library designed built on HDF5 to support EOS-specific
 data structures, namely Grid, Point, and Swath. The new data structures 
 are constructed from standard HDF data objects, using EOS conventions, through
 the use of a software library. A key feature of HDF-EOS files is that
 instrument-independent services, such as subsetting by geolocation, can be
 applied to the files across a wide variety of data products. 
 .
 This package contains include files and static libraries for HDF-EOS5.

=== debian/rules ===
#!/usr/bin/make -f

# Comment out this line for debugging
# export DH_VERBOSE:=1

# The magic rule for debhelper
%:
	dh $@ --with autoreconf

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)


# Disable checks: known bad test case ignored this release
DEB_CONFIGURE_EXTRA_FLAGS :=  --enable-shared --with-pic

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  DEB_CONFIGURE_EXTRA_FLAGS += --with-hdf5=/usr/include/hdf5/serial,/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

export DEB_CFLAGS_MAINT_APPEND=-D_HDFEOS5_THREADSAFE -Df2cFortran
export DEB_LDFLAGS_MAINT_APPEND=-lpthread

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)
	# Needed for the pthreads tests
	cp  samples/simple.txt testdrivers/threads

override_dh_auto_test:
	echo "Tests disabled in this version - known ok failures"

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/libhe5-hdfeos-dev/${LIBDIR}/pkgconfig debian/libhe5-hdfeos0/${LIBDIR}
	mv hdf-eos5.pc debian/libhe5-hdfeos-dev/${LIBDIR}/pkgconfig
	mv debian/tmp/${LIBDIR}/libhe5_hdfeos.so.0.0.0  debian/libhe5-hdfeos0/${LIBDIR}
	cp debian/tmp/usr/lib/*/*.a debian/libhe5-hdfeos-dev/${LIBDIR}
	cp -a samples/* debian/libhe5-hdfeos-dev/usr/share/doc/libhe5-hdfeos-dev/examples
	chmod -x debian/libhe5-hdfeos-dev/usr/share/doc/libhe5-hdfeos-dev/examples/*
	dh_link -p libhe5-hdfeos-dev ${LIBDIR}/libhe5_hdfeos.so.0.0.0 ${LIBDIR}/libhe5_hdfeos.so
	dh_link -p libhe5-hdfeos0   ${LIBDIR}/libhe5_hdfeos.so.0.0.0 ${LIBDIR}/libhe5_hdfeos.so.0

=== debian/watch ===
 # format version number, currently 3; this line is compulsory!
version=3

# This the format for an FTP site:
# Full-site-with-pattern  [Version  [Action]]
opts=dversionmangle=s/\+dfsg\.\d+$// \
ftp://edhs1.gsfc.nasa.gov/edhs/hdfeos5/latest_release/HDF-EOS5\.(.*)\.tar\.Z \
	debian uupdate
